<%@ page import="java.util.*, com.hlcl.rql.as.*" session="false" isThreadSafe="true" %>
<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN">

<HTML>
<HEAD>
<META http-equiv="Content-Type" content="text/html; charset=ISO-8859-1">
<%
// get variables
ResourceBundle b = ResourceBundle.getBundle("com.hlcl.rql.as.rql_fw");
String cssUrl = b.getString("cssUrl");
%>
<link href="<%=cssUrl%>" rel="styleSheet" type="text/css">
<TITLE>Show template language variant (LV) dependency</TITLE>
</HEAD>

<BODY>
<%
// get all RedDot session/project values from request
String logonGuid = request.getParameter("logonGuid");
String sessionKey = request.getParameter("sessionKey");
String projectGuid = request.getParameter("projectGuid");
String templateGuid = request.getParameter("templateGuid");

// open project
CmsClient client = new CmsClient (logonGuid);
Project project = client.getProject (sessionKey, projectGuid);
Template template = project.getTemplateByGuid(templateGuid);
%>	

<!-- page title, mandatory -->
<div class="block">
<table class="pageTitleTable" cellspacing="0" cellpadding="0">
    <tr>
        <td class="pageTitleGrey">Show template language variant (LV) dependency</td>
    </tr>
</table>
</div>

<div class="block">
<p>This script shows for all content elements if they are language variant dependent or not.</p>
<p><strong>Folder: <%=template.getTemplateFolder().getName() %><br />
Template: <%=template.getName() %></strong></p>
</div>

<!-- result or exception block -->
<div class="block">
<p>The table contains all content elements of this template.</p>
<p>LV dependent elements which are <span style="background-color: #80FF80;">changeable in Smart Edit are signaled green</span>. 
LV dependent elements which are <span style="background-color: #FF8040;">NOT changeable in Smart Edit are signaled red</span>.</p>
<table class="listTable" style="border-collapse:collapse" cellspacing="0" cellpadding="3">
<thead>
<tr>
 <th class="listHead" style="width:25%; text-align:left;">Element name</th>  
 <th class="listHead" style="width:25%; text-align:left;">Element type</th>  
 <th class="listHead" style="width:25%; text-align:left;">One value for all LVs</th>  
 <th class="listHead" style="width:25%; text-align:left;">Different values per LV</th>  
</tr>
</thead>
<tbody>
<%
try {
	// prepare totals
	int independent = 0;
	int dependent = 0;
	
	// write out all elements
	java.util.List<TemplateElement> elements = template.getContentElements();
	for (TemplateElement templateElement : elements) {
		String color = "white";
		if(templateElement.isLanguageVariantDependent()) {
			dependent++;
			color = "#FF8040";
			if (template.isElementChangeableInSmartEditByName(templateElement)) {
				color = "#80FF80";
			}
		}
		if(templateElement.isLanguageVariantIndependent()) {
			independent++;
		}
%>
<tr>
 <td class="borderedTextRow" style="font-size:100%; background-color:<%=color %>"><%=templateElement.getName()%></td>
 <td class="borderedTextRow" style="font-size:100%; background-color:<%=color %>"><%=templateElement.getTypeName()%></td>
 <td class="borderedTextRow" style="font-size:100%; text-align:center; background-color:<%=color %>"><%= templateElement.isLanguageVariantIndependent() ? "<b>true</b>" : "false" %></td>
 <td class="borderedTextRow" style="font-size:100%; text-align:center; background-color:<%=color %>"><%= templateElement.isLanguageVariantDependent() ? "<b>true</b>" : "false" %></td>
</tr>
<%
	} // end for all elements
%>
<tr>
 <td class="borderedTextRow" style="font-size:100%; text-align:right;" colspan="2"><b>Totals</b></td>
 <td class="borderedTextRow" style="font-size:100%; text-align:center;"><b><%=independent%></b></td>
 <td class="borderedTextRow" style="font-size:100%; text-align:center;"><b><%=dependent%></b></td>
</tr>
</tbody>
</table>
<br>
<p><%=elements.size()%> template elements found.</p>
<p><strong>
<% 
if (elements.size() == independent) {
	out.write("Pages are LV independent; will be never translated.");
} 
if (dependent > 0) {
	out.write("Pages are LV dependent; have to be translated.");
}  
%>
</strong></p>
<br />
<h2>Show template language variant dependency ends successfully.</h2>
<%
} catch (RQLException ex) {
	out.println("<h2>Error occurred</h2>");
	out.print(ex.getMessage());
	System.err.println(ex.getMessage());
	ex.printStackTrace();
	if (ex.getReason() != null) {
		out.print(ex.getReason().getMessage());
		System.err.println(ex.getReason().getMessage());
		ex.getReason().printStackTrace();
	}
}
%>
<form>
<input type="submit" value="Close window" onClick="javascript:window.close()">&nbsp;
</form>
</div>

</BODY>
</HTML>
